if not Recount then return end
local Recount = Recount
local RecountMitigation = LibStub("AceAddon-3.0"):NewAddon("RecountMitigation", "AceEvent-3.0", "AceTimer-3.0")
RecountMitigation.Version = 6.0
local RL = LibStub("AceLocale-3.0"):GetLocale("Recount")
local L = LibStub("AceLocale-3.0"):GetLocale("RecountMitigation")

local SPELLSCHOOL_PHYSICAL = 1
local SPELLSCHOOL_HOLY = 2
local SPELLSCHOOL_FIRE = 4
local SPELLSCHOOL_NATURE = 8
local SPELLSCHOOL_NATUREFIRE = SPELLSCHOOL_FIRE + SPELLSCHOOL_NATURE
local SPELLSCHOOL_FROST = 16
local SPELLSCHOOL_FROSTFIRE = SPELLSCHOOL_FIRE + SPELLSCHOOL_FROST
local SPELLSCHOOL_SHADOW = 32
local SPELLSCHOOL_ARCANE = 64

local PHYSICAL = 1
local MAGICAL = 2
local ALL = 3

local mAbsorbs = {
	[116631] = function() local _,_,_,_,_,_,_,_,_,_,_,_,_,_,v,_ = UnitBuff("player", "Colossus") return (v), nil end,
	[77535]  = function() local _,_,_,_,_,_,_,_,_,_,_,_,_,_,v,_ = UnitBuff("player", "Blood Shield") return (v), true end, --Physical Only (true)
	[65148]  = function() local _,_,_,_,_,_,_,_,_,_,_,_,_,_,v,_ = UnitBuff("player", "Sacred Shield") return (v), nil end,
	[17]     = function() local _,_,_,_,_,_,_,_,_,_,_,_,_,_,v,_ = UnitBuff("player", "Power Word: Shield") return (v), nil end,
	[86273]  = function() local _,_,_,_,_,_,_,_,_,_,_,_,_,_,v,_ = UnitBuff("player", "Illuminated Healing") return (v), nil end,
	[47753]  = function() local _,_,_,_,_,_,_,_,_,_,_,_,_,_,v,_ = UnitBuff("player", "Divine Aegis") return (v), nil end,
	[7812]   = function() local _,_,_,_,_,_,_,_,_,_,_,_,_,_,v,_ = UnitBuff("player", "Sacrifice") return (v), nil end,
	[64413]  = function() local _,_,_,_,_,_,_,_,_,_,_,_,_,_,v,_ = UnitBuff("player", "Protection of Ancient Kings") return (v), nil end,
	[71586]  = function() local _,_,_,_,_,_,_,_,_,_,_,_,_,_,v,_ = UnitBuff("player", "Hardened Skin") return (v), nil end,
	[36481]  = function() local _,_,_,_,_,_,_,_,_,_,_,_,_,_,v,_ = UnitBuff("player", "Arcane Barrier") return (v), nil end,
	[57350]  = function() local _,_,_,_,_,_,_,_,_,_,_,_,_,_,v,_ = UnitBuff("player", "Illusionary Barrier") return (v), nil end,
	[17252]  = function() local _,_,_,_,_,_,_,_,_,_,_,_,_,_,v,_ = UnitBuff("player", "Sacrifice") return (v), nil end,
	[115295] = function() local _,_,_,_,_,_,_,_,_,_,_,_,_,_,v,_ = UnitBuff("player", "Guard") return (v), nil end,
}
local mLeft = {}

-- look at combining HTD events as they will be the only ones with times instead of nil. must add check when nessessary below
-- (value, school, type, customDuration)
-- Value = a percentage or amount of damage mitigation
-- School = All, Physical or Magical
-- Type = Percentage or Amount
-- customDuration = duration of spell for HTD

--41377 - Shielded Skyflare Diamond
--52295 - Effulgent Shadowspirit Diamond
--76897 - Effulgent Primal Diamond

--name, link = GetItemGem(itemID, index)
--use for head meta gem
--gem1, gem2, gem3 = GetInventoryItemGems(slot)

local gtK = {
[0] = 5234,-- Default Level 103 as boss fights are most important
[1] = 157,
[2] = 167,
[3] = 177,
[4] = 187,
[5] = 197, 
[6] = 207,
[7] = 217,
[8] = 227,
[9] = 237,
[10] = 247, 
[11] = 257,
[12] = 267,
[13] = 277,
[14] = 287,
[15] = 297, 
[16] = 307,
[17] = 317,
[18] = 327,
[19] = 337,
[20] = 347, 
[21] = 357,
[22] = 367,
[23] = 377,
[24] = 387,
[25] = 397, 
[26] = 407,
[27] = 417,
[28] = 427,
[29] = 437,
[30] = 447, 
[31] = 457,
[32] = 467,
[33] = 477,
[34] = 487,
[35] = 497, 
[36] = 507,
[37] = 517,
[38] = 527,
[39] = 537,
[40] = 547, 
[41] = 557,
[42] = 567,
[43] = 577,
[44] = 587,
[45] = 597, 
[46] = 607,
[47] = 617,
[48] = 627,
[49] = 637,
[50] = 647, 
[51] = 657,
[52] = 667,
[53] = 677,
[54] = 687,
[55] = 697, 
[56] = 707,
[57] = 717,
[58] = 727,
[59] = 737,
[60] = 747, 
[61] = 757,
[62] = 767,
[63] = 777,
[64] = 787,
[65] = 797, 
[66] = 807,
[67] = 817,
[68] = 827,
[69] = 837,
[70] = 847, 
[71] = 857,
[72] = 867,
[73] = 877,
[74] = 887,
[75] = 897, 
[76] = 907,
[77] = 917,
[78] = 927,
[79] = 937,
[80] = 947, 
[81] = 957,
[82] = 967,
[83] = 977,
[84] = 987,
[85] = 997, 
[86] = 1007,
[87] = 1017,
[88] = 1027,
[89] = 1037,
[90] = 1047, 
[91] = 1185,
[92] = 1342,
[93] = 1518,
[94] = 1718,
[95] = 1945, 
[96] = 2201,
[97] = 2491,
[98] = 2819,
[99] = 3190,
[100] = 3610, 
[101] = 4086,
[102] = 4624,
[103] = 5234,
[104] = 5923,
[105] = 6704, 
[106] = 7587,
[107] = 8587,
[108] = 9718
};

local mBuffs = {
	[71]     = function() return (0.25), ALL, nil end, -- Defensive Stance (Unconfirmed)
	[871]    = function() return (0.40), ALL, nil end, -- Shield Wall (Unconfirmed)
	[14771]  = function() return (0.06), ALL, nil end, -- Glyph of Inner Sanctum (Unconfirmed)
	[15473]  = function() return (0.15), ALL, nil end, -- Shadowform (Unconfirmed)
	[22812]  = function() return (0.20), ALL, nil end, -- Barkskin (Unconfirmed)
	[24858]  = function() return (0.15), ALL, nil end, -- Moonkin Form (Unconfirmed)
	[30823]  = function() return (0.30), ALL, nil end, -- Shamanistic Rage (Unconfirmed)
	[31850]  = function() return (0.20), ALL, nil end, -- Ardent Defender
	[33206]  = function() return (0.40), ALL, nil end, -- Pain Suppression (Unconfirmed)
	[45182]  = function() return (0.80), ALL, nil end, -- Cheating Death (Unconfirmed)
	[48263]  = function() return (0.10), ALL, nil end, -- Blood Presence
	[48792]  = function() return (0.50), ALL, nil end, -- Icebound Fortitude
	[49222]  = function() return (0.20), ALL, nil end, -- Bone Shield (Unconfirmed)
	[54924]  = function() return (0.20), ALL, nil end, -- Glyph of Divine Protection (Unconfirmed)
	[55684]  = function() return (0.10), ALL, nil end, -- Glyph of Fade (Unconfirmed)
	[63329]  = function() return (0.60), ALL, nil end, -- Glyph of Shield Wall (Unconfirmed)
	[65116]  = function() return (0.10), ALL, nil end, -- Stoneform
	[65544]  = function() return (0.90), ALL, nil end, -- Dispersion (Unconfirmed)
	[81164]  = function() return (0.45), ALL, nil end, -- Will of the Necropolis (Unconfirmed)
	[81782]  = function() return (0.25), ALL, nil end, -- Power Word: Barrier (Unconfirmed)
	[105805] = function() return (0.15), ALL, nil end, -- Sanctuary (Unconfirmed - Not working)
	[110575] = function() return (0.20), ALL, nil end, -- Icebound Fortitude - Symbosis (Unconfirmed)
	[113075] = function() return (0.10), ALL, nil end, -- Barkskin - Symbosis (Unconfirmed)
	[115213] = function() return (0.20), ALL, nil end, -- Avert Harm (Unconfirmed)
	[86659]  = function() return (0.50), ALL, 8 end, -- Guardian of Ancient Kings -- maybe monitor buff instead
	[30482]  = function() return (0.06), PHYSICAL, nil end, -- Molten Armor (Unconfirmed)
	[63269]  = function() return (0.40), PHYSICAL, nil end, -- Glyph of Cloak of Shadows (Unconfirmed)
	[132403] = function() return (0.25 + (GetMastery()/200)), PHYSICAL, nil end, -- Shield of the Righteous
	[137593] = function() return (0.20), ALL, nil end, -- Indomitable Primal Diamond (Meta Gem, Unconfirmed)
	[999998] = function() return (GetCombatRatingBonus(CR_VERSATILITY_DAMAGE_TAKEN)/100), ALL, nil end, -- Versatility
	[999999] = function(l) 
	if type(l) ~= "number" then lvl = 0 else lvl = l end
	return (UnitArmor("player")/(UnitArmor("player") + gtK[lvl] )), PHYSICAL, false end, -- Armor
	[498]    = function() return (0.40), MAGICAL, nil end, -- Divine Protection
	[31821]  = function() return (0.20), MAGICAL, nil end, -- Devotion Aura
	[48707]  = function() return (0.75), MAGICAL, nil end, -- Anti-Magic Shell (Unconfirmed)
	[50461]  = function() return (0.75), MAGICAL, nil end, -- Anti-Magic Zone (Unconfirmed)
	
}

local mBuffRemoveHTD = {}

local DetailTitles={}
DetailTitles.DamageMitigation={
	TopNames = RL["Ability Name"],
	TopCount = RL["Count"],
	TopAmount = RL["Damage"],
	BotNames = L["Protected"],
	BotMin = RL["Min"],
	BotAvg = RL["Avg"],
	BotMax = RL["Max"],
	BotAmount = RL["Count"]
}
DetailTitles.DamageReducedBy={
	TopNames = RL["Ability Name"],
	TopCount = RL["Count"],
	TopAmount = RL["Damage"],
	BotNames = RL["Player/Mob Name"],
	BotMin = RL["Min"],
	BotAvg = RL["Avg"],
	BotMax = RL["Max"],
	BotAmount = RL["Count"]
}

local mActive={}
local Epsilon=0.000000000000000001
local math_floor = math.floor
function RecountMitigation:Round100(num)
	return math_floor((num * 100) + 0.5) / 100
end
function RecountMitigation:OnInitialize()
end
function RecountMitigation:OnEnable()
	if not Recount then return end
	RecountMitigation:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED", "CombatLogEvent")
	RecountMitigation:RegisterEvent("UNIT_SPELLCAST_SUCCEEDED", "mEventHTD")
	RecountMitigation:mBuffApplied(time(), _, _, "player", _, _, "player", _, 999998, "Versatility")--apply armor to player as a buff
	RecountMitigation:mBuffApplied(time(), _, _, "player", _, _, "player", _, 999999, "Armor")--apply armor to player as a buff
	--need to apply meta gem to player as a buff here and also add/remove when changing helmet
end
function RecountMitigation:OnDisable()
	RecountMitigation:UnregisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
end
------------------
-- MELEE DAMAGE	--
------------------
function RecountMitigation:MeleeDamage(timestamp, eventtype, srcGUID, srcName, srcFlags, dstGUID, dstName, dstFlags, amount, overkill, school, resisted, blocked, absorbed, critical, glancing, crushing, isOffHand, multistrike)
	RecountMitigation:CalDM(srcName, dstName, RL["Melee"], SPELLSCHOOL_PHYSICAL, amount, 0, timestamp, absorbed, blocked, resisted, srcGUID)
end
------------------
-- MELEE MISS	--
------------------
function RecountMitigation:MeleeMiss(timestamp, eventtype, srcGUID, srcName, srcFlags, dstGUID, dstName, dstFlags, missType, isOffHand, multistrike, amountMissed)
	RecountMitigation:CalDM(srcName, dstName, RL["Melee"], SPELLSCHOOL_PHYSICAL, 0, 0, timestamp, amountMissed, nil, nil, srcGUID)
end
------------------
-- SPELL DAMAGE	--
------------------
function RecountMitigation:SpellDamage(timestamp, eventtype, srcGUID, srcName, srcFlags, dstGUID, dstName, dstFlags, spellId, spellName, spellSchool, amount, overkill, school, resisted, blocked, absorbed, critical, glancing, crushing, isOffHand, multistrike)
	if eventtype == "RANGE_DAMAGE" then spellSchool = school end
	if eventtype == "SPELL_PERIODIC_DAMAGE" then
		spellName = spellName .." ("..RL["DoT"]..")"
	end
	RecountMitigation:CalDM(srcName, dstName, spellName, spellSchool, amount, spellId, timestamp, absorbed, blocked, resisted, srcGUID)
end
------------------
-- SPELL MISS	--
------------------
function RecountMitigation:SpellMiss(timestamp, eventtype, srcGUID, srcName, srcFlags, dstGUID, dstName, dstFlags, spellId, spellName, spellSchool, missType, isOffHand, multistrike, amountMissed)
	if eventtype == "RANGE_MISSED" then spellSchool = school end
		if eventtype == "SPELL_PERIODIC_MISSED" then
			spellName = spellName .." ("..RL["DoT"]..")"
		end
	RecountMitigation:CalDM(srcName, dstName, spellName, spellSchool, 0, spellId, timestamp, amountMissed, nil, nil, srcGUID)
end
------------------
-- ENVIROMENTAL	--
------------------
function RecountMitigation:EnvironmentalDamage(timestamp, eventtype, srcGUID, srcName, srcFlags, dstGUID, dstName, dstFlags, enviromentalType, amount, overkill, school, resisted, blocked, absorbed, critical, glancing, crushing)
	RecountMitigation:CalDM("Environment", dstName, Recount:FixCaps(enviromentalType), school, amount, spellId, timestamp, absorbed, blocked, resisted, srcGUID)
end
----------------------------------------------------------------------
--																	--
--  FUNCTION : MITIGATION BUFF APPLIED								--
--																	--
----------------------------------------------------------------------
function RecountMitigation:mBuffApplied(timestamp, eventtype, srcGUID, srcName, srcFlags, dstGUID, dstName, dstFlags, spellId, spellName, spellSchool, auraType, amount)
	if not mBuffs[spellId] and not mAbsorbs[spellId] then return end
	if UnitIsUnit(dstName, "player") then dstName = UnitName("player") end
	if UnitIsUnit(srcName, "player") then srcName = UnitName("player") end
	
	if mBuffs[spellId] then --FIX
		if ({mBuffs[spellId]()}) [3] then --If custom duration (HTD)
			mBuffRemoveHTD[spellId] = mBuffRemoveHTD[spellId] or {}
			mBuffRemoveHTD[spellId]["dstName"] = dstName
			mBuffRemoveHTD[spellId]["timer"] = RecountMitigation:ScheduleTimer("mBuffRemoved", ({mBuffs[spellId]()}) [3], spellId)
		end
	end --FIX
	
	mActive[dstName] = mActive[dstName] or {}
	if mActive[dstName][spellId] then --If spell already active and its a HTD
		if mBuffs[spellId] then --FIX
			if ({mBuffs[spellId]()}) [3] then --FIX
				RecountMitigation:CancelTimer(mBuffRemoveHTD[spellId]["timer"], false)
				mBuffRemoveHTD[spellId]["timer"] = RecountMitigation:ScheduleTimer("mBuffRemoved", ({mBuffs[spellId]()}) [3], spellId)
			end --FIX
		end --FIX
	end
	--print("Mitigation Buff: ", spellName, "[", spellId, "] applied")
	mActive[dstName][spellId] = timestamp
	if mAbsorbs[spellId] then
		mLeft[spellId] = (mAbsorbs[spellId]())
	end	
end
----------------------------------------------------------------------
--																	--
--  FUNCTION : MITIGATION BUFF REMOVED								--
--																	--
----------------------------------------------------------------------
function RecountMitigation:mBuffRemoved(timestamp, eventtype, srcGUID, srcName, srcFlags, dstGUID, dstName, dstFlags, spellId, spellName, spellSchool, auraType, amount)
	if not mBuffs[spellId] and not mBuffRemoveHTD[timestamp] and not mAbsorbs[spellId] then return end
	if mBuffRemoveHTD[timestamp] then
		dstName = mBuffRemoveHTD[timestamp]["dstName"]
		spellId = timestamp
		mBuffRemoveHTD[spellId] = nil
	end
	local dstDRBuffs = mActive[dstName]
	if not dstDRBuffs or not dstDRBuffs[spellId] then return end
	--print("Mitigation Buff: ", spellName, "[", spellId, "] removed")
	mActive[dstName][spellId] = nil
end

local mEvent =
{
	["SWING_DAMAGE"]			= RecountMitigation.MeleeDamage,
	["SWING_MISSED"]			= RecountMitigation.MeleeMiss,
	["RANGE_DAMAGE"]			= RecountMitigation.SpellDamage,
	["RANGE_MISSED"]			= RecountMitigation.SpellMiss,
	["SPELL_DAMAGE"]			= RecountMitigation.SpellDamage,
	["SPELL_MISSED"]			= RecountMitigation.SpellMiss,
	["SPELL_PERIODIC_DAMAGE"]	= RecountMitigation.SpellDamage,
	["SPELL_PERIODIC_MISSED"]	= RecountMitigation.SpellMiss,
	["DAMAGE_SHIELD"]			= RecountMitigation.SpellDamage,
	["DAMAGE_SPLIT"]			= RecountMitigation.SpellDamage,
	["ENVIRONMENTAL_DAMAGE"]	= RecountMitigation.EnvironmentalDamage,
	["SPELL_AURA_APPLIED"]		= RecountMitigation.mBuffApplied,
	["SPELL_AURA_REFRESH"]		= RecountMitigation.mBuffApplied,
	["SPELL_AURA_REMOVED"]		= RecountMitigation.mBuffRemoved,
}

local mEventList
----------------------------------------------------------------------
--																	--
--  FUNCTION : COMBAT LOG EVENT										--
--																	--
----------------------------------------------------------------------
function RecountMitigation:CombatLogEvent(_,timestamp, eventtype, hideCaster, srcGUID, srcName, srcFlags, srcRaidFlags, dstGUID, dstName, dstFlags, dstRaidFlags, ...)
	if dstName and UnitIsUnit(dstName, "player") then dstName = UnitName("player") else return end
	if not Recount.db.profile.GlobalDataCollect or not Recount.CurrentDataCollect then return end
	if not Recount:CheckRetentionFromFlags(srcFlags) and not Recount:CheckRetentionFromFlags(dstFlags) then return end
	if srcName then	Recount:MatchGUID(srcName, srcGUID, srcFlags) else srcName = "No One" end
	
	--UnitGUID("unit")==destGUID then local hostilelevel=UnitLevel("unit") end

	mEventList = mEvent[eventtype]
	if mEventList then
		mEventList(self, timestamp, eventtype, srcGUID, srcName, srcFlags, dstGUID, dstName, dstFlags, ...)
	end
end
----------------------------------------------------------------------
--																	--
--  FUNCTION : UNIT SPELLCAST SUCCEEDED	EVENT FOR HTD BUFFS			--
--																	--
----------------------------------------------------------------------
function RecountMitigation:mEventHTD(eventtype, unitId, spellName, rank, lineId, spellId, timestamp)
	if unitId and UnitIsUnit(unitId, "player") then unitId = UnitName("player") else return end
	if not mBuffs[spellId] then return end
	if not ({mBuffs[spellId]()}) [3] then return end
	RecountMitigation:mBuffApplied(time(), eventtype, srcGUID, unitId, srcFlags, dstGUID, unitId, dstFlags, spellId, spellName, spellSchool, auraType, amount)
end
----------------------------------------------------------------------
--																	--
--  FUNCTION : CALCULATE DAMAGE MITIGATION							--
--																	--
----------------------------------------------------------------------
function RecountMitigation:CalDM(source, victim, spellName, spellSchool, damage, spellId, timestamp, absorbed, blocked, resisted, srcGUID)
	if UnitIsUnit(victim, "player") then victim = UnitName("player") end
	if UnitIsUnit(source, "player") then source = UnitName("player") end
	if spellName == nil then
		print("spellName Unknown - spellId: ", spellId)
		spellName = "Unknown"
	end
	--------------
	-- BLOCKED	--
	--------------
	if blocked ~= nil then
		RecountMitigation:AddDM("Blocked", blocked, "Blocked", victim)
	end
	--------------
	-- ABSORBED	--
	--------------
	if absorbed ~= nil then
		mAbsorbed = absorbed
		for mAbsorbId, mAbsorb in pairs(mAbsorbs) do
			if mAbsorbs[mAbsorbId] then --Fix
				if not(({mAbsorbs[mAbsorbId]()}) [2] and spellSchool ~= SPELLSCHOOL_PHYSICAL) then
					local mAbsorbName = GetSpellInfo(mAbsorbId)					
					if mLeft[mAbsorbId] and mAbsorbed > 0 then
						--print("mAbsorbId",mAbsorbId)
						--print("mLeft",mLeft[mAbsorbId])
						--print("mAbsorbName",mAbsorbName)
						if mAbsorbed >= mLeft[mAbsorbId] then
							mAbsorbedAmount = mLeft[mAbsorbId]
							mLeft[mAbsorbId] = nil
							mAbsorbed = mAbsorbed - mAbsorbedAmount
						else
							mLeft[mAbsorbId] = mLeft[mAbsorbId] - mAbsorbed
							mAbsorbedAmount = mAbsorbed
							mAbsorbed = 0
						end
						--print("mAbsorbName",mAbsorbName,"mAbsorbedAmount",mAbsorbedAmount,"victim",victim)
						RecountMitigation:AddDM(mAbsorbName, mAbsorbedAmount, mAbsorbName, victim)
					end
				end --Fix
			end --Fix
		end
		if mAbsorbed > 0 then
			RecountMitigation:AddDM("Absorbed", mAbsorbed, "Absorbed", victim)
			mAbsorbed = 0
		end
	end
	--------------
	-- RESISTED	--
	--------------
	if resisted ~= nil then
		RecountMitigation:AddDM("Resisted", resisted, "Resisted", victim)
	end	
	----------------------------
	-- DAMAGE MITIGATION BUFF --
	----------------------------
	local dstDRBuffs = mActive[victim]
	if not dstDRBuffs then return end
	if damage <= 0 and ((absorbed or 0) + (blocked or 0) + (resisted or 0)) <= 0 then return end
	local mPhysical = 0
	local mMagical = 0
	local mPhysicalTotal = 0
	local mMagicalTotal = 0
	for mSpellId, dmBuffed in pairs(dstDRBuffs) do
		if dmBuffed then
			if mBuffs[mSpellId] then --Fix
				if ({mBuffs[mSpellId]()}) [2] == PHYSICAL or ({mBuffs[mSpellId]()}) [2] == ALL then
					mPhysical = 1 - ((1-mPhysical)*(1-(mBuffs[mSpellId](UnitLevel("target")))))
					mPhysicalTotal = mPhysicalTotal + (mBuffs[mSpellId](UnitLevel("target")))
				end
				if ({mBuffs[mSpellId]()}) [2] == MAGICAL or ({mBuffs[mSpellId]()}) [2] == ALL then
					mMagical  = 1 - ((1-mMagical)*(1-(mBuffs[mSpellId]())))
					mMagicalTotal = mMagicalTotal + (mBuffs[mSpellId]())
				end
			end
		end
	end
	
	for mSpellId, dmBuffed in pairs(dstDRBuffs) do
		if dmBuffed then
			if mBuffs[mSpellId] then --Fix
				mAmount = 0
				if spellSchool == SPELLSCHOOL_PHYSICAL and (({mBuffs[mSpellId]()}) [2] == PHYSICAL or ({mBuffs[mSpellId]()}) [2] == ALL) then
					if damage <= 0 then
						damage = ((absorbed or 0) + (blocked or 0) + (resisted or 0))
					end
					if mBuffs[mSpellId] then
						mAmount = math_floor((((math.ceil(damage/(1-mPhysical))*mPhysical) / mPhysicalTotal)*((mBuffs[mSpellId](UnitLevel("target")))))+0.5+Epsilon)
					end
				end
				if spellSchool ~= SPELLSCHOOL_PHYSICAL and (({mBuffs[mSpellId]()}) [2] == MAGICAL or ({mBuffs[mSpellId]()}) [2] == ALL) then
					if damage <= 0 then
						damage = ((absorbed or 0) + (blocked or 0) + (resisted or 0))
					end
					if mBuffs[mSpellId] then
						mAmount = math_floor((((math.ceil(damage/(1-mMagical))*mMagical) / mMagicalTotal)*((mBuffs[mSpellId]())))+0.5+Epsilon)
					end
				end
				if mAmount > 0 then
					local mSpellName = GetSpellInfo(mSpellId)
					if mSpellId == 999999 then
						mSpellName = "Armor"
					end
					if mSpellId == 999998 then
						mSpellName = "Versatility"
					end
					--if mAmount > 200000 then
					--	print("Error? mAmount: ", mAmount, " OrgHit: ")
					--end
					RecountMitigation:AddDM(spellName, mAmount, mSpellName, victim)
				end
			end --Fix
		end --Fix
	end
end
----------------------------------------------------------------------
--																	--
--  FUNCTION : ADD DAMAGE MITIGATION								--
--																	--
----------------------------------------------------------------------
function RecountMitigation:AddDM(spellName, mAmount, mSpellName, victim)
	if Recount.db2.combatants[victim] then
		local sourceData = Recount.db2.combatants[victim]
		Recount:AddAmount(sourceData, "TotalDamageMitigation", mAmount)
		Recount:AddTableDataStats(sourceData, "DamageMitigation", spellName, victim, mAmount)
		Recount:AddTableDataStats(sourceData, "DamageReducedBy", mSpellName, victim, mAmount)
	end
end

function RecountMitigation:DataModesDamageMitigation(data, num)
	if not data then return 0, 0 end
	if num == 1 then
		return RecountMitigation:Round100((data.Fights[Recount.db.profile.CurDataSet].TotalDamageMitigation or 0), (data.Fights[Recount.db.profile.CurDataSet].TotalDamageMitigation or 0)/((data.Fights[Recount.db.profile.CurDataSet].ActiveTime or 0) + Epsilon))
	else
		return (data.Fights[Recount.db.profile.CurDataSet].TotalDamageMitigation or 0), {{data.Fights[Recount.db.profile.CurDataSet].DamageReducedBy, " "..L["'s Damage Mitigation Abilities"], DetailTitles.DamageReducedBy}, {data.Fights[Recount.db.profile.CurDataSet].DamageMitigation, L["'s Damage Mitigation"], DetailTitles.DamageMitigation}}
	end
end
----------------------------------------------------------------------
--																	--
--  FUNCTION : DAMAGE MITIGATION TOOLTIP							--
--																	--
----------------------------------------------------------------------
function RecountMitigation:TooltipFuncsDamageMitigation(name, data)
	GameTooltip:ClearLines()
	GameTooltip:AddLine(name)
	tTotal = {}
	tTotal[L["Incoming Damage"]] = {}
	tTotal[L["Incoming Damage"]]["amount"] = (data.Fights[Recount.db.profile.CurDataSet].DamageTaken or 0) + (data.Fights[Recount.db.profile.CurDataSet].TotalDamageMitigation or 0)
	Recount:AddSortedTooltipData(L["Incoming Damage Before Mitigation"], tTotal,1)
	GameTooltip:AddLine("")
	tBreakdown = {}
	tBreakdown[L["Damage Taken"]] = {}
	tBreakdown[L["Damage Mitigated"]] = {}
	tBreakdown[L["Damage Taken"]]["amount"] = (data.Fights[Recount.db.profile.CurDataSet].DamageTaken or 0)
	tBreakdown[L["Damage Mitigated"]]["amount"] = (data.Fights[Recount.db.profile.CurDataSet].TotalDamageMitigation or 0)
	Recount:AddSortedTooltipData(L["of Incoming Damage"], tBreakdown,2)
	GameTooltip:AddLine("")
	tSelfHeals = {}
	tSelfHeals[L["Damage Self Healed"]] = {}
	tSelfHeals[L["Damage Not Actioned"]] = {}
	if data.Fights[Recount.db.profile.CurDataSet].HealedWho and data.Fights[Recount.db.profile.CurDataSet].HealedWho[UnitName("player")] and data.Fights[Recount.db.profile.CurDataSet].HealedWho[UnitName("player")]["amount"] then
		SelfHeals = data.Fights[Recount.db.profile.CurDataSet].HealedWho[UnitName("player")]["amount"]
	end
	tSelfHeals[L["Damage Self Healed"]]["amount"] = (SelfHeals or 0) - (data.Fights[Recount.db.profile.CurDataSet].Absorbs or 0)
	tSelfHeals[L["Damage Not Actioned"]]["amount"] = (data.Fights[Recount.db.profile.CurDataSet].DamageTaken or 0) - ((SelfHeals or 0) - (data.Fights[Recount.db.profile.CurDataSet].Absorbs or 0))
	Recount:AddSortedTooltipData(L["of Damage Taken"], tSelfHeals,2)
	GameTooltip:AddLine("")
	Recount:AddSortedTooltipData(L["of Damage Mitigated (Top 3)"], data and data.Fights[Recount.db.profile.CurDataSet] and data.Fights[Recount.db.profile.CurDataSet].DamageReducedBy, 3)
	GameTooltip:AddLine("<"..RL["Click for more Details"]..">",0,0.9,0)
end

Recount:AddModeTooltip(L["Damage Mitigation"], RecountMitigation.DataModesDamageMitigation, RecountMitigation.TooltipFuncsDamageMitigation, nil,nil,nil,nil)